/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("cordova-plugin-file.Entry",function(t,e,n){function i(t,e,n,i,o,a){this.isFile=!!t,this.isDirectory=!!e,this.name=n||"",this.fullPath=i||"",this.filesystem=o||null,this.nativeURL=a||null}var o=t("cordova/argscheck"),a=t("cordova/exec"),r=t("./FileError"),s=t("./Metadata");i.prototype.getMetadata=function(t,e){o.checkArgs("FF","Entry.getMetadata",arguments);var n=t&&function(e){var n=new s({size:e.size,modificationTime:e.lastModifiedDate});t(n)},i=e&&function(t){e(new r(t))};a(n,i,"File","getFileMetadata",[this.toInternalURL()])},i.prototype.setMetadata=function(t,e,n){o.checkArgs("FFO","Entry.setMetadata",arguments),a(t,e,"File","setMetadata",[this.toInternalURL(),n])},i.prototype.moveTo=function(e,n,i,s){o.checkArgs("oSFF","Entry.moveTo",arguments);var l=s&&function(t){s(new r(t))},f=this.toInternalURL(),c=n||this.name,u=function(n){if(n){if(i){var o=n.filesystemName||n.filesystem&&n.filesystem.name,a=o?new FileSystem(o,{name:"",fullPath:"/"}):new FileSystem(e.filesystem.name,{name:"",fullPath:"/"}),s=n.isDirectory?new(t("./DirectoryEntry"))(n.name,n.fullPath,a,n.nativeURL):new(t("cordova-plugin-file.FileEntry"))(n.name,n.fullPath,a,n.nativeURL);i(s)}}else l&&l(r.NOT_FOUND_ERR)};a(u,l,"File","moveTo",[f,e.toInternalURL(),c])},i.prototype.copyTo=function(e,n,i,s){o.checkArgs("oSFF","Entry.copyTo",arguments);var l=s&&function(t){s(new r(t))},f=this.toInternalURL(),c=n||this.name,u=function(n){if(n){if(i){var o=n.filesystemName||n.filesystem&&n.filesystem.name,a=o?new FileSystem(o,{name:"",fullPath:"/"}):new FileSystem(e.filesystem.name,{name:"",fullPath:"/"}),s=n.isDirectory?new(t("./DirectoryEntry"))(n.name,n.fullPath,a,n.nativeURL):new(t("cordova-plugin-file.FileEntry"))(n.name,n.fullPath,a,n.nativeURL);i(s)}}else l&&l(r.NOT_FOUND_ERR)};a(u,l,"File","copyTo",[f,e.toInternalURL(),c])},i.prototype.toInternalURL=function(){return this.filesystem&&this.filesystem.__format__?this.filesystem.__format__(this.fullPath,this.nativeURL):void 0},i.prototype.toURL=function(){return this.nativeURL?this.nativeURL:this.toInternalURL()||"file://localhost"+this.fullPath},i.prototype.toNativeURL=function(){return console.log("DEPRECATED: Update your code to use 'toURL'"),this.toURL()},i.prototype.toURI=function(){return console.log("DEPRECATED: Update your code to use 'toURL'"),this.toURL()},i.prototype.remove=function(t,e){o.checkArgs("FF","Entry.remove",arguments);var n=e&&function(t){e(new r(t))};a(t,n,"File","remove",[this.toInternalURL()])},i.prototype.getParent=function(e,n){o.checkArgs("FF","Entry.getParent",arguments);var i=this.filesystem,s=e&&function(n){var o=t("./DirectoryEntry"),a=new o(n.name,n.fullPath,i,n.nativeURL);e(a)},l=n&&function(t){n(new r(t))};a(s,l,"File","getParent",[this.toInternalURL()])},n.exports=i});